/****************************************************************************
   Program:     $Id: getlocalip.c,v 1.1 2006/01/18 14:37:34 rbeverly Exp $
   Author:      Rob Beverly <rbeverly@mit.edu>
   Date:        $Date: 2006/01/18 14:37:34 $
   Description: Hack to obtain local IP address - no good portable method
****************************************************************************/
#include "spoof.h"

int getlocalip(struct in_addr *addr) {
    char ac[80];
	int i;
	struct hostent *phe;

#ifdef _WIN32
    if (gethostname(ac, sizeof(ac)) == SOCKET_ERROR) {
        printf("WSAError: %d\n", WSAGetLastError());
        return -1;
    }
#else
    if (gethostname(ac, sizeof(ac)) < 0) {
        perror("gethostname()");
        return -1;
    }
#endif
    if (DEBUG) printf("Host name is %s.\n", ac);

    if ((phe = gethostbyname(ac)) == 0) {
        perror("gethostbyname()");
        return -1;
    }

    for (i=0; phe->h_addr_list[i] != 0; ++i) {
        memcpy(addr, phe->h_addr_list[i], sizeof(struct in_addr));
    }
    
    return 1;
}

#if 0
int main(int argc, char *argv[])
{
    struct in_addr addr;
#ifdef _WIN32
    WSADATA wsaData;
    if (WSAStartup(MAKEWORD(1, 1), &wsaData) != 0) {
        return 255;
    }
#endif

    if (getlocalip(&addr) < 0) {
		printf("error getting local address\n");
	} else {
        printf("Address: %s", inet_ntoa(addr));
	}

#ifdef _WIN32
    WSACleanup();
#endif
	exit(0);
}
#endif
